#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#include "syntax.h"
#include "process.h"

void process(tSyntaxElement* tree, tProcessingData* pdata) {
	tProcessingData* pd = pdata;
	bool deffound = false;
	if (pd == NULL) {
		pd = calloc(1,sizeof(tProcessingData));
	}
	if (se_istraversable(tree))
		if (((tSyntaxElement*)tree->content)->type == TOKEN && ((tSyntaxElement*)tree->content)->next != NULL) {
			tSyntaxElement* token = (tSyntaxElement*)tree->content;
			if (strcmp((char*)token->content,"def") == 0) {
				char* replacethis = token->next->content;
				tSyntaxElement* replacewiththis = token->next->next;
				tProcessingData* npd = malloc(sizeof(tSyntaxElement));
				npd->replacethis = replacethis;
				npd->replacewiththis = replacewiththis;
				npd->prev = pd;
				pd = npd;
				deffound = true;
			}
		}
	if (tree->next != NULL) {
		process(tree->next, pd);
	}
	if (!deffound) {
		if (se_istraversable(tree)) {
			process((tSyntaxElement*)tree->content, pd);
		}
		while (1) {
			if (pd->replacethis == NULL)
				break;
			// Да блядь.
			if (tree->type == TOKEN)
				if (strcmp(tree->content, pd->replacethis) == 0) {
					free(tree->content);
					tSyntaxElement* clone = se_clone_no_next(pd->replacewiththis, tree);
					tree->content = clone->content;
					tree->type = clone->type;
				}
			if (pd->prev != NULL)
				pd = pd->prev;
			else
				break;
		}
	}
}
